### [Main.go](Main.go)

Entry point.

The command line interface expects a command like `build` as the first argument.
Commands are implemented as functions in the `cli` directory.
Each command has its own set of parameters.

### [Build.go](Build.go)

The build command creates a new `Build` instance with the given directory and calls the `Run` method.

If no directory is specified, it will use the current directory.

If the `--dry` flag is specified, it will perform all tasks except the final write to disk.
This flag should be used in most tests and benchmarks to avoid needless disk writes.

```shell
q build
q build examples/hello
q build examples/hello --dry
```

Adding the `-a` or `--assembler` flag shows the generated assembly instructions:

```shell
q build examples/hello -a
```

Adding the `-v` or `--verbose` flag shows verbose compiler information:

```shell
q build examples/hello -v
```